<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_Discount2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_Discount2 extends AbstractStructArrayBase
{
    /**
     * The ChildB
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_Discount[]
     */
    public $ChildB;
    /**
     * Constructor method for ArrayOfJPSOAP_Discount2
     * @uses ArrayOfJPSOAP_Discount2::setChildB()
     * @param \StructType\JPSOAP_Discount[] $childB
     */
    public function __construct(array $childB = array())
    {
        $this
            ->setChildB($childB);
    }
    /**
     * Get ChildB value
     * @return \StructType\JPSOAP_Discount[]|null
     */
    public function getChildB()
    {
        return $this->ChildB;
    }
    /**
     * This method is responsible for validating the values passed to the setChildB method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChildB method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChildBForArrayConstraintsFromSetChildB(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_Discount2ChildBItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_Discount2ChildBItem instanceof \StructType\JPSOAP_Discount) {
                $invalidValues[] = is_object($arrayOfJPSOAP_Discount2ChildBItem) ? get_class($arrayOfJPSOAP_Discount2ChildBItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_Discount2ChildBItem), var_export($arrayOfJPSOAP_Discount2ChildBItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ChildB property can only contain items of type \StructType\JPSOAP_Discount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ChildB value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Discount[] $childB
     * @return \ArrayType\ArrayOfJPSOAP_Discount2
     */
    public function setChildB(array $childB = array())
    {
        // validation for constraint: array
        if ('' !== ($childBArrayErrorMessage = self::validateChildBForArrayConstraintsFromSetChildB($childB))) {
            throw new \InvalidArgumentException($childBArrayErrorMessage, __LINE__);
        }
        $this->ChildB = $childB;
        return $this;
    }
    /**
     * Add item to ChildB value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Discount $item
     * @return \ArrayType\ArrayOfJPSOAP_Discount2
     */
    public function addToChildB(\StructType\JPSOAP_Discount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_Discount) {
            throw new \InvalidArgumentException(sprintf('The ChildB property can only contain items of type \StructType\JPSOAP_Discount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ChildB[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_Discount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_Discount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ChildB
     */
    public function getAttributeName()
    {
        return 'ChildB';
    }
}
